<script setup lang="ts">
// ----------------------------------------------------------------
// Import
// ----------------------------------------------------------------

import { useConnectionStore } from "@/stores/useConnectionStore";
import { useSubmissionStore } from "@/stores/useSubmissionStore";

// ----------------------------------------------------------------
// Props
// ----------------------------------------------------------------

const props = defineProps({
  connectionId: {
    type: String,
    required: true,
  },
});

// ----------------------------------------------------------------
// Variables
// ----------------------------------------------------------------

const connectionStore = useConnectionStore();
const submissionStore = useSubmissionStore();

const currentConnection = ref<any>(null);
currentConnection.value = connectionStore.connectionMap.get(props.connectionId);

const sharedFields = ref({});
const privateFields = ref({});

const sharedFieldSchemas = ref({});
const privateFieldSchemas = ref({});
const loadingConnection = ref(false);

const validationErrors = ref([]);
const invalidCount = ref(0);

const changesMade = ref(false);

const errorMessageSnackbar = reactive({
  show: false,
  message: "",
});

// ----------------------------------------------------------------
// Functions
// ----------------------------------------------------------------

/**
 * Establishes a connection by either updating an existing connection or creating a new one.
 */
async function connect() {
  loadingConnection.value = true;
  try {
    await updateConnection();
  } catch (error) {
    loadingConnection.value = false;
    errorMessageSnackbar.message = error?.response._data.details[0].message
      ? error.response._data.details[0].message
      : "An error occurred, please try again.";
    errorMessageSnackbar.show = true;
  }
  await connectionStore.fetchConnections();
  loadingConnection.value = false;
  changesMade.value = false;
}

/**
 * Updates an existing connection with new private fields
 * by calling the `updateConnection` method from the `connectionStore`.
 */
async function updateConnection() {
  // combine the array of objects into a single object holding all the params
  const privateParams = Object.assign({}, ...Object.values(privateFields.value));
  await connectionStore.updateConnection(currentConnection.value.id, privateParams);
}
</script>

<template>
  <div class="d-flex flex-column justify-space-between h-100">
    <v-sheet class="d-flex align-center">
      <v-badge
        :color="connectionStore.getStatus(currentConnection.id, currentConnection.status).color"
        inline
        class="mr-2"
      />
      <DataObjectIcon :data-object-icon="currentConnection.connector.icon" />
      <h1>{{ currentConnection.connector.name }}</h1>
    </v-sheet>
    <hr class="mb-3">
    <ConnectionFields
      v-model:current-connector="currentConnection.connector"
      v-model:current-connection="currentConnection"
      v-model:shared-fields="sharedFields"
      v-model:private-fields="privateFields"
      v-model:shared-field-schemas="sharedFieldSchemas"
      v-model:private-field-schemas="privateFieldSchemas"
      v-model:validation-errors="validationErrors"
      v-model:invalid-count="invalidCount"
      v-model:changes-made="changesMade"
      :expandable-private-params="true"
      :read-only-shared-fields="true"
      :read-only-private-fields="submissionStore.currentMember?.value.role.role !== 'owner'"
    />

    <div v-if="changesMade" class="d-flex flex-row-reverse">
      <v-btn
        :loading="loadingConnection"
        :disabled="invalidCount !== 0"
        class="ma-2"
        width="150"
        @click="connect()"
      >
        Connect
      </v-btn>
    </div>
  </div>
  <v-snackbar
    v-model="errorMessageSnackbar.show"
    :attach="true"
    :timeout="5000"
    color="error"
  >
    {{ errorMessageSnackbar.message }}
    <template v-slot:action="{ attrs }">
      <v-btn
        color="white"
        text
        v-bind="attrs"
        @click="errorMessageSnackbar.show = false"
      >
        Close
      </v-btn>
    </template>
  </v-snackbar>
</template>

<style>
.bgGray {
  background: rgb(var(--v-theme-background-gray));
}
</style>
